<?php
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/*
    Written by Arek Jankowski, Neptune Web, Inc. 
    www.neptuneweb.com
    support@neptneweb.com
*/

/* Query CloudFront in a remote location, showing me all possible headers and views of a page a user might see at that edge location.

This script should be hosted on a remote location you are interested in troubleshooting. */    

define(PAGETOTEST,'[PAGE ON YOUR AMAZON CLOUD FRONT SITE e.g. http://www.acme.com/service/index.html TO TEST]');
define(DOMAINTOTEST,'[DOMAIN OF SITE TO TEST, e.g. www.acme.com]');
define(DISTRIBUTION_DOMAIN,'[CLOUDFROUNT DISTRIBUTION DOMAIN e.g. d1dd88x9x995aul.cloudfront.net]');

/* fetch all IPs CloudFront uses. You will get multiple IPs from your point-of-presence (which may return differnent content). */
$ips = array();
$ret = dns_get_record(DISTRIBUTION_DOMAIN, DNS_ANY, $authns, $addtl);

foreach($ret as $dns) {
  $ip = $dns['ip'];
  print "$ip\n";
  $ips[$ip] = $ip;
}
print "\n";

function gzdecode($string) { // no support for 2nd argument
        return file_get_contents('compress.zlib://data:who/cares;base64,'. base64_encode($string));
}

foreach($ips as $ip) {

	$ch = curl_init($ip);
	curl_setopt($ch, CURLOPT_URL, PAGETOTEST);
	curl_setopt($ch, CURLOPT_HEADER, 1);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array("Host: " . DOMAINTOTEST,
	'Connection: keep-alive',
	'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
	'User-Agent: Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.22 (KHTML, like Gecko) Chrome/25.0.1364.152 Safari/537.22',
	'Accept-Encoding: gzip,deflate,sdch',
	'Accept-Language: en-US,en;q=0.8',
	'Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.3',
	));
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$response = curl_exec($ch);
	$info = curl_getinfo($ch);
	curl_close($ch);

	$header = substr($response, 0, $info['header_size']);
	$body = substr($response, -$info['download_content_length']);
	$body = gzdecode($body);

	/* Print out the IP you fetched the content from, followed by headers */

	print '<pre>';
	print "$ip\n";
	print $header;
	print "size_download: " . $info['size_download'] . "\n";
	print "body: " . strlen($body) . "\n";
	print "\n";
	print '</pre>';

	/* Then print out the page body so you can visually see if the content is stale */

	$c = preg_match('/<body.*?<\/body>/is', $body, $m);
	var_dump ($m);
	print "\n\n";
	/* don't overload server or be abusive in any way */
	sleep(2);
}



